function NKMrss(cp,cy,cg,cpW,cw,ci,cphiw,fspace,T,params,ws,epsilons)

% Function file to calculate risky steady state

rstar=params.rstar;
sigma = params.sigma;
Gamma = params.Gamma;
rho = params.rho;
rhou = params.rhou;

d = zeros(T,1);
u = zeros(T,1);
pi = zeros(T,1);
y = zeros(T,1);
g = zeros(T,1);
piW = zeros(T,1);
w = zeros(T,1);
i = ones(T,1)*rstar;
phiw = zeros(T,1);
Epi = zeros(T,1);

for j = 2:1:T;
    pi(j) = funeval(cp,fspace,[d(j) w(j-1) u(j)]);
    y(j) = funeval(cy,fspace,[d(j) w(j-1) u(j)]);
    g(j) = funeval(cg,fspace,[d(j) w(j-1) u(j)]);
    piW(j) = funeval(cpW,fspace,[d(j) w(j-1) u(j)]);
    w(j) = funeval(cw,fspace,[d(j) w(j-1) u(j)]);
    i(j) = funeval(ci,fspace,[d(j) w(j-1) u(j)]);
    phiw(j) = funeval(cphiw,fspace,[d(j) w(j-1) u(j)]);
end;

for k=1:1:length(ws);
    df = rho*d+ones(T,1)*epsilons(k,1);
    uf = rhou*u+ones(T,1)*epsilons(k,2);
    Epi = Epi + ws(k)*funeval(cp,fspace,[df w uf]);
end;

rr = i-Epi;
nrr = rstar*ones(T,1)+sigma*d;


nrr = nrr(end)*4;
pi_del = pi(end)*4;
y_del = y(end);
g_del = g(end);
piW_del = piW(end)*4;
w_del = w(end);
i_del = i(end)*4;
rr_del = rr(end)*4;
ygap_del = y_del-Gamma*g_del;

 
save risky_steady_state_del.mat nrr pi_del y_del g_del piW_del w_del i_del rr_del ygap_del;
