function NKMeqresp_d(cp,cy,cg,cpW,cw,ci,cphiw,fspace,params,ws,epsilons,m_w)


uncostdevd = params.uncostdevd;
rho = params.rho;
rhoa = params.rhoa;
sigma = params.sigma;
rstar = params.rstar;
Gamma = params.Gamma;
nd = 1001;


grid_w = ones(nd,1)*m_w;
grid_a = zeros(nd,1);
grid_d = linspace(-3*uncostdevd,3*uncostdevd,nd)';

pi = funeval(cp,fspace,[grid_d grid_w grid_a]);
y = funeval(cy,fspace,[grid_d grid_w grid_a]);
g = funeval(cg,fspace,[grid_d grid_w grid_a]);
piW = funeval(cpW,fspace,[grid_d grid_w grid_a]);
w = funeval(cw,fspace,[grid_d grid_w grid_a]);
i = funeval(ci,fspace,[grid_d grid_w grid_a]);
phiw = funeval(cphiw,fspace,[grid_d grid_w grid_a]);
ygap = y-Gamma*g;

nrr = rstar+sigma*grid_d;


Epi = zeros(nd,1);

for j=1:1:length(ws);
    df = rho*grid_d+ones(nd,1)*epsilons(j,1);
    af = rhoa*grid_a+ones(nd,1)*epsilons(j,2);
    Epi = Epi+ws(j)*funeval(cp,fspace,[df w af]);
end;

rr = i-Epi;

% figure;
% subplot(3,3,1);
% plot(4*nrr,ygap,'k-','LineWidth',2);
% title('Output gap');
% grid on;
% 
% subplot(3,3,2);
% plot(4*nrr,g,'k-','LineWidth',2);
% title('Government spending');
% grid on;
% 
% subplot(3,3,3);
% plot(4*nrr,4*pi,'k-','LineWidth',2);
% title('Price inflation');
% grid on;
% 
% subplot(3,3,4);
% plot(4*nrr,4*piW,'k-','LineWidth',2);
% title('Wage inflation');
% grid on;
% 
% subplot(3,3,5);
% plot(4*nrr,4*i,'k-','LineWidth',2);
% title('Nominal interest rate');
% grid on;
% 
% subplot(3,3,6);
% plot(4*nrr,4*rr,'k-','LineWidth',2);
% title('Real interest rate');
% grid on;
% 
% subplot(3,3,7);
% plot(4*nrr,w,'k-','LineWidth',2);
% title('Real wage');
% grid on;
% 
% subplot(3,3,8);
% plot(4*nrr,phiw,'k-','LineWidth',2);
% title('Lagrange multiplier');
% grid on;
% 
% subplot(3,3,9);
% plot(4*nrr,y,'k-','LineWidth',2);
% title('Output');
% grid on;

nrr = nrr*4;
pi_del = pi*4;
y_del = y;
g_del = g;
piW_del = piW*4;
w_del = w;
i_del = i*4;
rr_del = rr*4;
ygap_del = y_del-Gamma*g_del;
phiw_del = phiw;

 
save eqresp_del.mat nrr pi_del y_del g_del piW_del w_del i_del rr_del ygap_del phiw_del;

