function NKMirf_d_forecast(cp,cy,cg,cpW,cw,ci,cphiw,fspace,T,params,ws,epsilons,cufo)


q = 100;

uncostdevd = params.uncostdevd;
rho=params.rho;
rstar=params.rstar;
sigma = params.sigma;
Gamma = params.Gamma;
rhoa = params.rhoa;

cd ..
load simul_d_a_IRF.mat;
cd(cufo);
n = length(d_innos);

d = zeros(n,T+q);
a = zeros(n,T+q);
pi = zeros(n,T+q);
y = zeros(n,T+q);
g = zeros(n,T+q);
piW = zeros(n,T+q);
w = zeros(n,T+q);
i = zeros(n,T+q);
Epi = zeros(n,T+q);


for j = 2:1:T+q;
    d(:,j)=rho*d(:,j-1);
    a(:,j)=rhoa*a(:,j-1);
    if j ==q+2;
        d(:,j) = -3*uncostdevd;
    end;
    if j>q+2;
            d(:,j)=rho*d(:,j-1)+d_innos(:,j);
            a(:,j)=rhoa*a(:,j-1)+a_innos(:,j);
    end;
 
    pi(:,j) = funeval(cp,fspace,[d(:,j) w(:,j-1) a(:,j)]);
    y(:,j) = funeval(cy,fspace,[d(:,j) w(:,j-1) a(:,j)]);
    g(:,j) = funeval(cg,fspace,[d(:,j) w(:,j-1) a(:,j)]);
    piW(:,j) = funeval(cpW,fspace,[d(:,j) w(:,j-1) a(:,j)]);
    w(:,j) = funeval(cw,fspace,[d(:,j) w(:,j-1) a(:,j)]);
    i(:,j) = funeval(ci,fspace,[d(:,j) w(:,j-1) a(:,j)]);
    for k=1:1:length(ws);
        df = rho*d(:,j)+ones(n,1)*epsilons(k,1);
        af = rhoa*a(:,j)+ones(n,1)*epsilons(k,2);
        Epi(:,j) = Epi(:,j) + ws(k)*funeval(cp,fspace,[df w(:,j) af]);
    end;
end;

nrr = rstar*ones(n,T+q)+sigma*d;
rr = i-Epi;
ygap = y-Gamma*g;

% Mean
imean = mean(i);
pmean = mean(pi);
ymean = mean(y);
rrmean = mean(rr);
nrrmean = mean(nrr);
gmean = mean(g);
pWmean = mean(piW);
wmean = mean(w);
ygapmean = mean(ygap);


% Quantiles
quantvec = [0.05 0.125 0.25 0.5 0.75 0.875 0.95];
lqv = length(quantvec);

pquant = quantile(pi,quantvec); %5 x (T+q)
yquant = quantile(y,quantvec);
iquant = quantile(i,quantvec);
rrquant = quantile(rr,quantvec);
nrrquant = quantile(nrr,quantvec);
gquant = quantile(g,quantvec);
pWquant = quantile(piW,quantvec);
wquant = quantile(w,quantvec);
ygapquant = quantile(ygap,quantvec);

pquantd = [pquant(1,:); diff(pquant,1,1)]';
yquantd = [yquant(1,:); diff(yquant,1,1)]';
iquantd = [iquant(1,:); diff(iquant,1,1)]';
rrquantd = [rrquant(1,:); diff(rrquant,1,1)]';
nrrquantd = [nrrquant(1,:); diff(nrrquant,1,1)]';
gquantd = [gquant(1,:); diff(gquant,1,1)]';
pWquantd = [pWquant(1,:); diff(pWquant,1,1)]';
wquantd = [wquant(1,:); diff(wquant,1,1)]';
ygapquantd = [ygapquant(1,:); diff(ygapquant,1,1)]';

adjusthist = kron(ones(q+5,1),[10^(-48) 10^(-49) 10^(-50) 0 10^(-50) 10^(-49) 10^(-48)]);
adjusthist = [adjusthist; zeros(T+q-(q+5),lqv)];

pquantd = pquantd+adjusthist;
yquantd = yquantd+adjusthist;
iquantd = iquantd+adjusthist;
rrquantd = rrquantd+adjusthist;
nrrquantd = nrrquantd+adjusthist;
gquantd = gquantd+adjusthist;
pWquantd = pWquantd+adjusthist;
wquantd = wquantd+adjusthist;
ygapquantd = ygapquantd+adjusthist;

% Plot
iquantdplot = iquantd(q+1:T+q,:)*4;
pquantdplot = pquantd(q+1:T+q,:)*4;
yquantdplot = yquantd(q+1:T+q,:);
rrquantdplot = rrquantd(q+1:T+q,:)*4;
nrrquantdplot = nrrquantd(q+1:T+q,:)*4;
gquantdplot = gquantd(q+1:T+q,:);
pWquantdplot = pWquantd(q+1:T+q,:)*4;
wquantdplot = wquantd(q+1:T+q,:);
ygapquantdplot = ygapquantd(q+1:T+q,:);

imeanplot = imean(q+1:T+q)*4;
pmeanplot = pmean(q+1:T+q)*4;
ymeanplot = ymean(q+1:T+q);
rrmeanplot = rrmean(q+1:T+q)*4;
nrrmeanplot = nrrmean(q+1:T+q)*4;
gmeanplot = gmean(q+1:T+q);
pWmeanplot = pWmean(q+1:T+q)*4;
wmeanplot = wmean(q+1:T+q);
ygapmeanplot = ygapmean(q+1:T+q);

t = (0:1:T+q-1-q);

% figure;
scrsz = get(0,'ScreenSize');
h = figure('Position',[1 0 scrsz(3)/3 scrsz(4)/2]);
subplot(3,3,9);
h = area(t,nrrquantdplot);
set(h,'LineStyle','none')
set(h(1),'FaceColor','none') % white
set(h(2),'FaceColor',[0.04314 0.5176 0.7804])
set(h(3),'FaceColor',[0.1922 0.7529 0.9412])
set(h(4),'FaceColor',[0.7373 0.8784 0.9882])
set(h(5),'FaceColor',[0.7373 0.8784 0.9882])
set(h(6),'FaceColor',[0.1922 0.7529 0.9412])
set(h(7),'FaceColor',[0.04314 0.5176 0.7804])
hold on
plot(t,sum(nrrquantdplot(:,1:4),2),'-r',t,nrrmeanplot,'r--','LineWidth',2);  % median forecast in black
box on;
xlim([0 20]);
ylim([-7 7]);
title('Natural real rate of interest','FontSize',12,'FontName','Arial');
xlabel('Quarters');

subplot(3,3,7);
h = area(t,iquantdplot);
set(h,'LineStyle','none')
set(h(1),'FaceColor','none') % white
set(h(2),'FaceColor',[0.04314 0.5176 0.7804])
set(h(3),'FaceColor',[0.1922 0.7529 0.9412])
set(h(4),'FaceColor',[0.7373 0.8784 0.9882])
set(h(5),'FaceColor',[0.7373 0.8784 0.9882])
set(h(6),'FaceColor',[0.1922 0.7529 0.9412])
set(h(7),'FaceColor',[0.04314 0.5176 0.7804])
hold on
plot(t,sum(iquantdplot(:,1:4),2),'-r',t,imeanplot,'r--','LineWidth',2);  % median forecast in black
box on;
xlim([0 20]);
ylim([0 6.5]);
title('Nominal interest rate','FontSize',12,'FontName','Arial');
xlabel('Quarters');

% figure;
subplot(3,3,2);
h = area(t,pquantdplot);
set(h,'LineStyle','none')
set(h(1),'FaceColor','none') % white
set(h(2),'FaceColor',[0.04314 0.5176 0.7804])
set(h(3),'FaceColor',[0.1922 0.7529 0.9412])
set(h(4),'FaceColor',[0.7373 0.8784 0.9882])
set(h(5),'FaceColor',[0.7373 0.8784 0.9882])
set(h(6),'FaceColor',[0.1922 0.7529 0.9412])
set(h(7),'FaceColor',[0.04314 0.5176 0.7804])
hold on
plot(t,sum(pquantdplot(:,1:4),2),'-r',t,pmeanplot,'r--','LineWidth',2);  % median forecast in black
box on;
xlim([0 20]);
ylim([-1.75 0.75]);
title('Price inflation','FontSize',12,'FontName','Arial');

% figure;
subplot(3,3,5);
h = area(t,yquantdplot);
set(h,'LineStyle','none')
set(h(1),'FaceColor','none') % white
set(h(2),'FaceColor',[0.04314 0.5176 0.7804])
set(h(3),'FaceColor',[0.1922 0.7529 0.9412])
set(h(4),'FaceColor',[0.7373 0.8784 0.9882])
set(h(5),'FaceColor',[0.7373 0.8784 0.9882])
set(h(6),'FaceColor',[0.1922 0.7529 0.9412])
set(h(7),'FaceColor',[0.04314 0.5176 0.7804])
hold on
plot(t,sum(yquantdplot(:,1:4),2),'-r',t,ymeanplot,'r--','LineWidth',2);  % median forecast in black
box on;
xlim([0 20]);
ylim([-3 1]);
title('Output','FontSize',12,'FontName','Arial');

% figure;
subplot(3,3,8);
h = area(t,rrquantdplot);
set(h,'LineStyle','none')
set(h(1),'FaceColor','none') % white
set(h(2),'FaceColor',[0.04314 0.5176 0.7804])
set(h(3),'FaceColor',[0.1922 0.7529 0.9412])
set(h(4),'FaceColor',[0.7373 0.8784 0.9882])
set(h(5),'FaceColor',[0.7373 0.8784 0.9882])
set(h(6),'FaceColor',[0.1922 0.7529 0.9412])
set(h(7),'FaceColor',[0.04314 0.5176 0.7804])
hold on
plot(t,sum(rrquantdplot(:,1:4),2),'-r',t,rrmeanplot,'r--','LineWidth',2);  % median forecast in black
box on;
xlim([0 20]);
ylim([0 6.5]);
title('Real interest rate','FontSize',12,'FontName','Arial');
xlabel('Quarters');

subplot(3,3,4);
h = area(t,gquantdplot);
set(h,'LineStyle','none')
set(h(1),'FaceColor','none') % white
set(h(2),'FaceColor',[0.04314 0.5176 0.7804])
set(h(3),'FaceColor',[0.1922 0.7529 0.9412])
set(h(4),'FaceColor',[0.7373 0.8784 0.9882])
set(h(5),'FaceColor',[0.7373 0.8784 0.9882])
set(h(6),'FaceColor',[0.1922 0.7529 0.9412])
set(h(7),'FaceColor',[0.04314 0.5176 0.7804])
hold on
plot(t,sum(gquantdplot(:,1:4),2),'-r',t,gmeanplot,'r--','LineWidth',2);  % median forecast in black
box on;
xlim([0 20]);
ylim([0 3]);
title('Government spending','FontSize',12,'FontName','Arial');

subplot(3,3,1);
h = area(t,ygapquantdplot);
set(h,'LineStyle','none')
set(h(1),'FaceColor','none') % white
set(h(2),'FaceColor',[0.04314 0.5176 0.7804])
set(h(3),'FaceColor',[0.1922 0.7529 0.9412])
set(h(4),'FaceColor',[0.7373 0.8784 0.9882])
set(h(5),'FaceColor',[0.7373 0.8784 0.9882])
set(h(6),'FaceColor',[0.1922 0.7529 0.9412])
set(h(7),'FaceColor',[0.04314 0.5176 0.7804])
hold on
plot(t,sum(ygapquantdplot(:,1:4),2),'-r',t,ygapmeanplot,'r--','LineWidth',2);  % median forecast in black
box on;
xlim([0 20]);
ylim([-4 1]);
title('Output gap','FontSize',12,'FontName','Arial');

subplot(3,3,3);
h = area(t,pWquantdplot);
set(h,'LineStyle','none')
set(h(1),'FaceColor','none') % white
set(h(2),'FaceColor',[0.04314 0.5176 0.7804])
set(h(3),'FaceColor',[0.1922 0.7529 0.9412])
set(h(4),'FaceColor',[0.7373 0.8784 0.9882])
set(h(5),'FaceColor',[0.7373 0.8784 0.9882])
set(h(6),'FaceColor',[0.1922 0.7529 0.9412])
set(h(7),'FaceColor',[0.04314 0.5176 0.7804])
hold on
plot(t,sum(pWquantdplot(:,1:4),2),'-r',t,pWmeanplot,'r--','LineWidth',2);  % median forecast in black
box on;
xlim([0 20]);
ylim([-1.8 0]);
title('Wage inflation','FontSize',12,'FontName','Arial');

subplot(3,3,6);
h = area(t,wquantdplot);
set(h,'LineStyle','none')
set(h(1),'FaceColor','none') % white
set(h(2),'FaceColor',[0.04314 0.5176 0.7804])
set(h(3),'FaceColor',[0.1922 0.7529 0.9412])
set(h(4),'FaceColor',[0.7373 0.8784 0.9882])
set(h(5),'FaceColor',[0.7373 0.8784 0.9882])
set(h(6),'FaceColor',[0.1922 0.7529 0.9412])
set(h(7),'FaceColor',[0.04314 0.5176 0.7804])
hold on
plot(t,sum(wquantdplot(:,1:4),2),'-r',t,wmeanplot,'r--','LineWidth',2);  % median forecast in black
box on;
xlim([0 20]);
ylim([-0.75 0.5]);
title('Real wage rate','FontSize',12,'FontName','Arial');
