function NKMeqresp_e(cp,cy,cg,cpW,cw,ci,cphiw,fspace,params,ws,epsilons,m_w)


uncostdeve = params.uncostdeve;
rho = params.rho;
rhoe = params.rhoe;
Gamma = params.Gamma;
nd = 1001;


grid_w = ones(nd,1)*m_w;
grid_d = zeros(nd,1);
grid_e = linspace(-3*uncostdeve,3*uncostdeve,nd)';

pi = funeval(cp,fspace,[grid_d grid_w grid_e]);
y = funeval(cy,fspace,[grid_d grid_w grid_e]);
g = funeval(cg,fspace,[grid_d grid_w grid_e]);
piW = funeval(cpW,fspace,[grid_d grid_w grid_e]);
w = funeval(cw,fspace,[grid_d grid_w grid_e]);
i = funeval(ci,fspace,[grid_d grid_w grid_e]);
phiw = funeval(cphiw,fspace,[grid_d grid_w grid_e]);
ygap = y-Gamma*g;

Epi = zeros(nd,1);

for j=1:1:length(ws);
    df = rho*grid_d+ones(nd,1)*epsilons(j,1);
    ef = rhoe*grid_e+ones(nd,1)*epsilons(j,2);
    Epi = Epi+ws(j)*funeval(cp,fspace,[df w ef]);
end;

rr = i-Epi;

% figure;
% subplot(3,3,1);
% plot(grid_u,ygap,'k-','LineWidth',2);
% title('Output gap');
% grid on;
% 
% subplot(3,3,2);
% plot(grid_u,g,'k-','LineWidth',2);
% title('Government spending');
% grid on;
% 
% subplot(3,3,3);
% plot(grid_u,4*pi,'k-','LineWidth',2);
% title('Price inflation');
% grid on;
% 
% subplot(3,3,4);
% plot(grid_u,4*piW,'k-','LineWidth',2);
% title('Wage inflation');
% grid on;
% 
% subplot(3,3,5);
% plot(grid_u,4*i,'k-','LineWidth',2);
% title('Nominal interest rate');
% grid on;
% 
% subplot(3,3,6);
% plot(grid_u,4*rr,'k-','LineWidth',2);
% title('Real interest rate');
% grid on;
% 
% subplot(3,3,7);
% plot(grid_u,w,'k-','LineWidth',2);
% title('Real wage');
% grid on;
% 
% subplot(3,3,8);
% plot(grid_u,phiw,'k-','LineWidth',2);
% title('Lagrange multiplier');
% grid on;
% 
% subplot(3,3,9);
% plot(grid_u,y,'k-','LineWidth',2);
% title('Output');
% grid on;

pi_del = pi*4;
y_del = y;
g_del = g;
piW_del = piW*4;
w_del = w;
i_del = i*4;
rr_del = rr*4;
ygap_del = y_del-Gamma*g_del;
phiw_del = phiw;

save eqresp_e_del.mat grid_e pi_del y_del g_del piW_del w_del i_del rr_del ygap_del phiw_del;

