% Equilibrium response comparison

clear all; close all; clc;

%% Natural real rate

load eqresp_bench.mat;
load eqresp_del.mat;


% figure;
% scrsz = get(0,'ScreenSize');
% h = figure('Position',[1 0 scrsz(3)/3.5 scrsz(4)/2]);

scrsz = get(0,'ScreenSize');
h = figure('Position',[1 0 scrsz(3)/3 scrsz(4)/2]);
subplot(3,3,1);
plot(nrr,ygap_del,'k-',nrr,ygap_bench,'k--','LineWidth',2);
title('Output gap');
axis([-7.15 12.15 -4 0.5]);

subplot(3,3,4);
plot(nrr,g_del,'k-',nrr,g_bench,'k--','LineWidth',2);
title('Government spending');
axis([-7.15 12.15 0 5]);

subplot(3,3,2);
plot(nrr,pi_del,'k-',nrr,pi_bench,'k--','LineWidth',2);
title('Price inflation');
axis([-7.15 12.15 -1 0]);

subplot(3,3,3);
plot(nrr,piW_del,'k-',nrr,piW_bench,'k--','LineWidth',2);
title('Wage inflation');
axis([-7.15 12.15 -1.5 0]);

subplot(3,3,7);
plot(nrr,i_del,'k-',nrr,i_bench,'k--','LineWidth',2);
title('Nominal interest rate');
axis([-7.15 12.15 0 12]);
xlabel('Natural real rate');

subplot(3,3,8);
plot(nrr,rr_del,'k-',nrr,rr_bench,'k--','LineWidth',2);
title('Real interest rate');
axis([-7.15 12.15 0 12]);
xlabel('Natural real rate');

subplot(3,3,6);
plot(nrr,w_del,'k-',nrr,w_bench,'k--','LineWidth',2);
title('Real wage rate');
axis([-7.15 12.15 -0.2 0]);

subplot(3,3,5);
plot(nrr,y_del,'k-',nrr,y_bench,'k--','LineWidth',2);
title('Output');
axis([-5.24 9.26 -2.5 0.5]);

subplot(3,3,9);
plot(nrr,i_del,'k-',nrr,i_bench,'k--','LineWidth',2);
title('Excerpt of nominal rate');
axis([0 2 0 1.5]);
xlabel('Natural real rate');


%% Price mark-up shock

clear all;

load eqresp_u_bench.mat;
load eqresp_u_del.mat;

scrsz = get(0,'ScreenSize');
h = figure('Position',[1 0 scrsz(3)/3 scrsz(4)/2]);
subplot(3,3,1);
plot(grid_u,ygap_del,'k-',grid_u,ygap_bench,'k--','LineWidth',2);
title('Output gap');
axis([-0.68 0.68 -0.6 0.8]);

subplot(3,3,4);
plot(grid_u,g_del,'k-',grid_u,g_bench,'k--','LineWidth',2);
title('Government spending');
axis([-0.68 0.68 -0.5 0.5]);

subplot(3,3,2);
plot(grid_u,pi_del,'k-',grid_u,pi_bench,'k--','LineWidth',2);
title('Price inflation');
axis([-0.68 0.68 -2.5 2.5]);

subplot(3,3,3);
plot(grid_u,piW_del,'k-',grid_u,piW_bench,'k--','LineWidth',2);
title('Wage inflation');
axis([-0.68 0.68 -0.15 0]);

subplot(3,3,7);
plot(grid_u,i_del,'k-',grid_u,i_bench,'k--','LineWidth',2);
title('Nominal interest rate');
axis([-0.68 0.68 0 4.5]);
xlabel('Price mark-up shock');

subplot(3,3,8);
plot(grid_u,rr_del,'k-',grid_u,rr_bench,'k--','LineWidth',2);
title('Real interest rate');
axis([-0.68 0.68 0 5]);
xlabel('Price mark-up shock');

subplot(3,3,6);
plot(grid_u,w_del,'k-',grid_u,w_bench,'k--','LineWidth',2);
title('Real wage rate');
axis([-0.68 0.68 -0.6 0.6]);

subplot(3,3,5);
plot(grid_u,y_del,'k-',grid_u,y_bench,'k--','LineWidth',2);
title('Output');
axis([-0.68 0.68 -0.8 1]);

subplot(3,3,9);
plot(grid_u,phiw_del,'k-',grid_u,phiw_bench,'k--','LineWidth',2);
title('Lagrange multiplier');
axis([-0.68 0.68 -0.05 0.06]);
xlabel('Price mark-up shock');
