function NKMeqresp_u(cp,cy,cg,cpW,cw,ci,cphiw,fspace,params,ws,epsilons,m_w)


uncostdevu = params.uncostdevu;
rho = params.rho;
rhou = params.rhou;
Gamma = params.Gamma;
nd = 1001;


grid_w = ones(nd,1)*m_w;
grid_d = zeros(nd,1);
grid_u = linspace(-4*uncostdevu,4*uncostdevu,nd)';

pi = funeval(cp,fspace,[grid_d grid_w grid_u]);
y = funeval(cy,fspace,[grid_d grid_w grid_u]);
g = funeval(cg,fspace,[grid_d grid_w grid_u]);
piW = funeval(cpW,fspace,[grid_d grid_w grid_u]);
w = funeval(cw,fspace,[grid_d grid_w grid_u]);
i = funeval(ci,fspace,[grid_d grid_w grid_u]);
phiw = funeval(cphiw,fspace,[grid_d grid_w grid_u]);
ygap = y-Gamma*g;

Epi = zeros(nd,1);

for j=1:1:length(ws);
    df = rho*grid_d+ones(nd,1)*epsilons(j,1);
    uf = rhou*grid_u+ones(nd,1)*epsilons(j,2);
    Epi = Epi+ws(j)*funeval(cp,fspace,[df w uf]);
end;

rr = i-Epi;

pi_bench = pi*4;
y_bench = y;
g_bench = g;
piW_bench = piW*4;
w_bench = w;
i_bench = i*4;
rr_bench = rr*4;
ygap_bench = y_bench-Gamma*g_bench;
phiw_bench = phiw;
 
save eqresp_u_bench.mat grid_u pi_bench y_bench g_bench piW_bench w_bench i_bench rr_bench ygap_bench phiw_bench;

