function NKMirf_e(cp,cy,cg,cpW,cw,ci,cphiw,fspace,T,params,ws,epsilons)

% Function file to construct IRFs


q = 100;

uncostdevu = params.uncostdevu;
rho = params.rho;
rstar = params.rstar;
sigma = params.sigma;
rhou = params.rhou;
Gamma = params.Gamma;

d = zeros(T+q,1);
u = zeros(T+q,1);
pi = zeros(T+q,1);
y = zeros(T+q,1);
g = zeros(T+q,1);
piW = zeros(T+q,1);
w = zeros(T+q,1);
i = ones(T+q,1)*rstar;
phiw = zeros(T+q,1);
Epi = zeros(T+q,1);

for j = 2:1:T+q;
    u(j)=rhou*u(j-1);
    if j ==q+2;
        u(j) = -3*uncostdevu;
    end;

    pi(j) = funeval(cp,fspace,[d(j) w(j-1) u(j)]);
    y(j) = funeval(cy,fspace,[d(j) w(j-1) u(j)]);
    g(j) = funeval(cg,fspace,[d(j) w(j-1) u(j)]);
    piW(j) = funeval(cpW,fspace,[d(j) w(j-1) u(j)]);
    w(j) = funeval(cw,fspace,[d(j) w(j-1) u(j)]);
    i(j) = funeval(ci,fspace,[d(j) w(j-1) u(j)]);
    phiw(j) = funeval(cphiw,fspace,[d(j) w(j-1) u(j)]);
end;

for k=1:1:length(ws);
    df = rho*d+ones(T+q,1)*epsilons(k,1);
    uf = rhou*u+ones(T+q,1)*epsilons(k,2);
    Epi = Epi + ws(k)*funeval(cp,fspace,[df w uf]);
end;

rr = i-Epi;
nrr = rstar*ones(T+q,1)+sigma*d;
ygap = y-Gamma*g;


t=1:1:T+1;
figure;
subplot(3,3,1);
plot(t,ygap(q:(T+q)),'LineWidth',2);
title('Output gap');
grid on;

subplot(3,3,2);
plot(t,g(q:(T+q)),'LineWidth',2);
title('Government spending');
grid on;

subplot(3,3,3);
plot(t,pi(q:(T+q)),'LineWidth',2);
title('Price inflation');
grid on;

subplot(3,3,4);
plot(t,piW(q:(T+q)),'LineWidth',2);
title('Wage inflation');
grid on;

subplot(3,3,5);
plot(t,i(q:(T+q)),'LineWidth',2);
title('Nominal interest rate');
grid on;

subplot(3,3,6);
plot(t,4*rr(q:(T+q)),t,4*nrr(q:(T+q)),'k--','LineWidth',2);
title('Real interest rate');
grid on;

subplot(3,3,7);
plot(t,w(q:(T+q)),'LineWidth',2);
title('Real wage rate');
grid on;

subplot(3,3,8);
plot(t,phiw(q:(T+q)),'LineWidth',2);
title('Lagrange multiplier phiw');
grid on;

subplot(3,3,9);
plot(t,y(q:(T+q)),'LineWidth',2);
title('Output');
grid on;

figure;
plot(t,u(q:(T+q)),'LineWidth',2);
title('Price mark-up shock');
grid on;
