function NKMrss(cp,cy,cg,cpW,cw,ci,cphiw,fspace,T,params,ws,epsilons)

% Function file to calculate risky steady state

rstar=params.rstar;
sigma = params.sigma;
Gamma = params.Gamma;
rho = params.rho;
rhoa = params.rhoa;

d = zeros(T,1);
a = zeros(T,1);
pi = zeros(T,1);
y = zeros(T,1);
g = zeros(T,1);
piW = zeros(T,1);
w = zeros(T,1);
i = ones(T,1)*rstar;
phiw = zeros(T,1);
Epi = zeros(T,1);

for j = 2:1:T;
    pi(j) = funeval(cp,fspace,[d(j) w(j-1) a(j)]);
    y(j) = funeval(cy,fspace,[d(j) w(j-1) a(j)]);
    g(j) = funeval(cg,fspace,[d(j) w(j-1) a(j)]);
    piW(j) = funeval(cpW,fspace,[d(j) w(j-1) a(j)]);
    w(j) = funeval(cw,fspace,[d(j) w(j-1) a(j)]);
    i(j) = funeval(ci,fspace,[d(j) w(j-1) a(j)]);
    phiw(j) = funeval(cphiw,fspace,[d(j) w(j-1) a(j)]);
end;

for k=1:1:length(ws);
    df = rho*d+ones(T,1)*epsilons(k,1);
    af = rhoa*a+ones(T,1)*epsilons(k,2);
    Epi = Epi + ws(k)*funeval(cp,fspace,[df w af]);
end;

rr = i-Epi;
nrr = rstar*ones(T,1)+sigma*d;


nrr = nrr(end)*4;
pi_bench = pi(end)*4;
y_bench = y(end);
g_bench = g(end);
piW_bench = piW(end)*4;
w_bench = w(end);
i_bench = i(end)*4;
rr_bench = rr(end)*4;
ygap_bench = y_bench-Gamma*g_bench;

 
save risky_steady_state_bench.mat nrr pi_bench y_bench g_bench piW_bench w_bench i_bench rr_bench ygap_bench;
