function [aper_nkpc,aper_is] = NKMaccuracy(smin,smax,neval,cp,cy,ci,fspace,epsilons,ws,params)

% Function file to evaluate the accuracy of the approximants for the policy
% functions


sigma = params.sigma;
kappa = params.kappa;
beta = params.beta;
rho = params.rho;
rstar = params.rstar;

fspace2 = fundefn('spli',neval,smin,smax); 
scoord2 = funnode(fspace2); 
snodes2 = gridmake(scoord2);


% Realisations
ysim = funeval(cy,fspace,snodes2);
psim = funeval(cp,fspace,snodes2);
isim = funeval(ci,fspace,snodes2);

% Expectations
Ep = zeros(length(ysim),1);
Ey = zeros(length(ysim),1);

for k=1:1:length(ws);
    df = rho*snodes2(:,1)+epsilons(k)*ones(length(ysim),1);
    Ep = Ep + ws(k)*funeval(cp,fspace,[df isim]);
    Ey = Ey + ws(k)*funeval(cy,fspace,[df isim]);
end;

aper_is = ysim -(Ey-1/sigma*(isim-Ep-rstar*ones(length(snodes2),1))+snodes2(:,1));
aper_nkpc = psim - (kappa*ysim+beta*Ep);