function NKMeqresp_e(cp,cy,cg,cpW,cw,ci,cphiw,fspace,params,ws,epsilons,m_w)


uncostdeve = params.uncostdeve;
rho = params.rho;
rhoe = params.rhoe;
Gamma = params.Gamma;
nd = 1001;


grid_w = ones(nd,1)*m_w;
grid_d = zeros(nd,1);
grid_e = linspace(-3*uncostdeve,3*uncostdeve,nd)';

pi = funeval(cp,fspace,[grid_d grid_w grid_e]);
y = funeval(cy,fspace,[grid_d grid_w grid_e]);
g = funeval(cg,fspace,[grid_d grid_w grid_e]);
piW = funeval(cpW,fspace,[grid_d grid_w grid_e]);
w = funeval(cw,fspace,[grid_d grid_w grid_e]);
i = funeval(ci,fspace,[grid_d grid_w grid_e]);
phiw = funeval(cphiw,fspace,[grid_d grid_w grid_e]);
ygap = y-Gamma*g;

Epi = zeros(nd,1);

for j=1:1:length(ws);
    df = rho*grid_d+ones(nd,1)*epsilons(j,1);
    ef = rhoe*grid_e+ones(nd,1)*epsilons(j,2);
    Epi = Epi+ws(j)*funeval(cp,fspace,[df w ef]);
end;

rr = i-Epi;

figure;
subplot(3,3,1);
plot(grid_e,ygap,'k-','LineWidth',2);
title('Output gap');
grid on;

subplot(3,3,2);
plot(grid_e,g,'k-','LineWidth',2);
title('Government spending');
grid on;

subplot(3,3,3);
plot(grid_e,4*pi,'k-','LineWidth',2);
title('Price inflation');
grid on;

subplot(3,3,4);
plot(grid_e,4*piW,'k-','LineWidth',2);
title('Wage inflation');
grid on;

subplot(3,3,5);
plot(grid_e,4*i,'k-','LineWidth',2);
title('Nominal interest rate');
grid on;

subplot(3,3,6);
plot(grid_e,4*rr,'k-','LineWidth',2);
title('Real interest rate');
grid on;

subplot(3,3,7);
plot(grid_e,w,'k-','LineWidth',2);
title('Real wage');
grid on;

subplot(3,3,8);
plot(grid_e,phiw,'k-','LineWidth',2);
title('Lagrange multiplier');
grid on;

subplot(3,3,9);
plot(grid_e,y,'k-','LineWidth',2);
title('Output');
grid on;

pi_bench = pi*4;
y_bench = y;
g_bench = g;
piW_bench = piW*4;
w_bench = w;
i_bench = i*4;
rr_bench = rr*4;
ygap_bench = y_bench-Gamma*g_bench;
phiw_bench = phiw;
 
save eqresp_e_bench.mat grid_e pi_bench y_bench g_bench piW_bench w_bench i_bench rr_bench ygap_bench phiw_bench;

