function NKMeqresp_w(cp,cy,cg,cpW,cw,ci,cphiw,fspace,params,ws,epsilons)


% Subroutines called:
% funeval (from CompEcon)

% close all;

uncostdevd = params.uncostdevd;
rho = params.rho;
rhoe = params.rhoe;
sigma = params.sigma;
rstar = params.rstar;
nd = 1001;

grid_w = linspace(-1,1,nd)';
grid_d = zeros(nd,1);
grid_dzlb = -3*uncostdevd*ones(nd,1);
grid_e = zeros(nd,1);

pi = funeval(cp,fspace,[grid_d grid_w grid_e]);
y = funeval(cy,fspace,[grid_d grid_w grid_e]);
g = funeval(cg,fspace,[grid_d grid_w grid_e]);
piW = funeval(cpW,fspace,[grid_d grid_w grid_e]);
w = funeval(cw,fspace,[grid_d grid_w grid_e]);
i = funeval(ci,fspace,[grid_d grid_w grid_e]);
phiw = funeval(cphiw,fspace,[grid_d grid_w grid_e]);

piz = funeval(cp,fspace,[grid_dzlb grid_w grid_e]);
yz = funeval(cy,fspace,[grid_dzlb grid_w grid_e]);
gz = funeval(cg,fspace,[grid_dzlb grid_w grid_e]);
piWz = funeval(cpW,fspace,[grid_dzlb grid_w grid_e]);
wz = funeval(cw,fspace,[grid_dzlb grid_w grid_e]);
iz = funeval(ci,fspace,[grid_dzlb grid_w grid_e]);
phiwz = funeval(cphiw,fspace,[grid_dzlb grid_w grid_e]);

nrr = rstar+sigma*grid_d;
nrrz = rstar+sigma*grid_dzlb;

Epi = zeros(nd,1);
Epiz = zeros(nd,1);

for j=1:1:length(ws);
    df = rho*grid_d+ones(nd,1)*epsilons(j,1);
    ef = rhoe*grid_e+ones(nd,1)*epsilons(j,2);
    dfz = rho*grid_dzlb+ones(nd,1)*epsilons(j,1);
    Epi = Epi+ws(j)*funeval(cp,fspace,[df w ef]);
    Epiz = Epiz+ws(j)*funeval(cp,fspace,[dfz wz ef]);
end;

rr = i-Epi;
rrz = iz-Epiz;

figure;
subplot(3,3,1);
plot(grid_w,y,'k-',grid_w,yz,'k--','LineWidth',2);
title('Output');
grid on;

subplot(3,3,2);
plot(grid_w,g,'k-',grid_w,gz,'k--','LineWidth',2);
title('Government spending');
grid on;

subplot(3,3,3);
plot(grid_w,4*pi,'k-',grid_w,4*piz,'k--','LineWidth',2);
title('Price inflation');
grid on;

subplot(3,3,4);
plot(grid_w,4*piW,'k-',grid_w,4*piWz,'k--','LineWidth',2);
title('Wage inflation');
grid on;

subplot(3,3,5);
plot(grid_w,4*i,'k-',grid_w,4*iz,'k--','LineWidth',2);
title('Nominal interest rate');
grid on;

subplot(3,3,6);
plot(grid_w,4*rr,'k-',grid_w,4*rrz,'k--','LineWidth',2);
title('Real interest rate');
grid on;

subplot(3,3,7);
plot(grid_w,w,'k-',grid_w,wz,'k--','LineWidth',2);
title('Real wage');
grid on;

subplot(3,3,8);
plot(grid_w,phiw,'k-',grid_w,phiwz,'k--','LineWidth',2);
title('Lagrange multiplier');
grid on;



% nrr = nrr*4;
% i_IRS = isim*4;
% p_IRS = psim*4;
% y_IRS = ysim;
% rr_IRS = rrsim*4;
% i_IRSz = isimzlb*4;
% p_IRSz = psimzlb*4;
% y_IRSz = ysimzlb;
% rr_IRSz = rrsimzlb*4;
%  
% eval(['save eqresp_IRS_xi_' num2str(xi) '.mat nrr y_IRS p_IRS i_IRS rr_IRS y_IRSz p_IRSz i_IRSz rr_IRSz;']);



 

