function NKMirf_d(cp,cy,cg,cpW,cw,ci,cphiw,fspace,T,params,ws,epsilons)

% Function file to construct IRFs


q = 100;

uncostdevd = params.uncostdevd;
rho=params.rho;
rstar=params.rstar;
sigma = params.sigma;
rhoe = params.rhoe;

d = zeros(T+q,1);
e = zeros(T+q,1);
pi = zeros(T+q,1);
y = zeros(T+q,1);
g = zeros(T+q,1);
piW = zeros(T+q,1);
w = zeros(T+q,1);
i = ones(T+q,1)*rstar;
phiw = zeros(T+q,1);
Epi = zeros(T+q,1);

for j = 2:1:T+q;
    d(j)=rho*d(j-1);
    if j ==q+2;
        d(j) = -3*uncostdevd;
    end;

    pi(j) = funeval(cp,fspace,[d(j) w(j-1) e(j)]);
    y(j) = funeval(cy,fspace,[d(j) w(j-1) e(j)]);
    g(j) = funeval(cg,fspace,[d(j) w(j-1) e(j)]);
    piW(j) = funeval(cpW,fspace,[d(j) w(j-1) e(j)]);
    w(j) = funeval(cw,fspace,[d(j) w(j-1) e(j)]);
    i(j) = funeval(ci,fspace,[d(j) w(j-1) e(j)]);
    phiw(j) = funeval(cphiw,fspace,[d(j) w(j-1) e(j)]);
end;

for k=1:1:length(ws);
    df = rho*d+ones(T+q,1)*epsilons(k,1);
    ef = rhoe*e+ones(T+q,1)*epsilons(k,2);
    Epi = Epi + ws(k)*funeval(cp,fspace,[df w ef]);
end;

rr = i-Epi;
nrr = rstar*ones(T+q,1)+sigma*d;


t=1:1:T+1;
figure;
subplot(3,3,1);
plot(t,y(q:(T+q)),'LineWidth',2);
title('Output');
grid on;

subplot(3,3,2);
plot(t,g(q:(T+q)),'LineWidth',2);
title('Government spending');
grid on;

subplot(3,3,3);
plot(t,4*pi(q:(T+q)),'LineWidth',2);
title('Price inflation');
grid on;

subplot(3,3,4);
plot(t,4*piW(q:(T+q)),'LineWidth',2);
title('Wage inflation');
grid on;

subplot(3,3,5);
plot(t,4*i(q:(T+q)),'LineWidth',2);
title('Nominal interest rate');
grid on;

subplot(3,3,6);
plot(t,4*rr(q:(T+q)),t,4*nrr(q:(T+q)),'k--','LineWidth',2);
title('Real interest rate');
grid on;

subplot(3,3,7);
plot(t,w(q:(T+q)),'LineWidth',2);
title('Real wage rate');
grid on;

subplot(3,3,8);
plot(t,phiw(q:(T+q)),'LineWidth',2);
title('Lagrange multiplier phiw');
grid on;
